// 版本号
var current_version = 0.1;
// 网站域名
var site_url = 'http://91yiliu.com/';
// API服务器域名及IP
//var api_url = 'http://91yiliu.ixcv.com:7864/wp-json';
//var api_url = 'http://192.168.1.101:7864/wp-json';
var api_url = 'http://www.91yiliu.com:7864/wp-json';
var img_server = 'http://www.91yiliu.com/';
// 高级的缓存操作
var cache = {
	size_key: 'cache_size',
	is_login_key: 'is_login',
	user_info_key: 'user_info',
	
	
	// set
	set: function(key, value) {
		console.log('cache.set');
		console.log(key);
		console.log(value);
		if (!plus.storage.getItem(key)) {
			var length = cache.size() + value.length;
			plus.storage.setItem(cache.size_key, '' + length);
		}
		plus.storage.setItem(key, value);
		return true;
	},
	// get
	get: function(key) {
		var data = plus.storage.getItem(key);
		return data;
	},
	// delete
	delete: function(key) {
		console.log('cache.delete');
		var value = plus.storage.getItem(key);
		if (value == null) {
			var length = cache.size();
			
		} else {
			var length = cache.size() - value.length;
		}
		plus.storage.removeItem(key);
		plus.storage.setItem(cache.size_key, '' + length);
		return true;
	},
	// clear
	clear: function(all) {
		if (!all) {
			var is_login = plus.storage.getItem(cache.is_login_key);
			var user_info = plus.storage.getItem(cache.user_info_key);
		}
		plus.storage.clear();
		plus.storage.setItem(cache.size_key, '0');
		if (!all) {
			plus.storage.setItem(cache.is_login_key, is_login);
			plus.storage.setItem(cache.user_info_key, user_info);
		}
		return true;
	},
	// size
	size: function() {
		console.log('cache.size');
		var size = plus.storage.getItem(cache.size_key);
		if (size == null) {
			plus.storage.setItem(cache.size_key, '0');
			size = 0;
		}
		console.log(size);
		return parseInt(size);
	}
};

// 网络相关方法
var network = {
	// 生成接口完整地址
	gen_url: function(uri) {
		console.log('network.gen_url');
		var full_url = api_url + uri;
		console.log(full_url);
		return full_url;
	},
	// 客户端是否在线
	is_online: function() {
		console.log('network.is_online');
		var network_status = true;
		if(mui.os.plus){
			if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE){
				mui.toast('网络不给力呀~~')
				network_status = false;
			}
		}
		console.log(network_status);
		return network_status;
	}
};

// 用户相关方法
var user = {
	// 是否已登录
	is_login: function() {
		console.log('user.is_login');
		var login_flag = plus.storage.getItem('is_login');
		console.log(login_flag);
		if (login_flag == null) {
			return false;
		} else {
			var user_info = plus.storage.getItem('user_info');
			console.log(user_info);
			if (user_info == null) {
				var login_info = JSON.parse(login_flag);
				var url = network.gen_url('/user/my');
				var data = {
					access_token: login_info.access_token
				};
				mui.get(url, data, function(resp) {
					plus.storage.setItem('user_info', resp)
				}, 'text');
			}
			return true;
		}
	},
	// 用户注册
	regist: function(account, vcode, password, recommendcode, successCallback, failCallback) {
		console.log('user.regist');
		if (network.is_online()) {
			var url = network.gen_url('/user/regist');
			var data = {
				account: account,
				vcode: vcode,
				uuid: plus.device.uuid,
				password: password,
				recommendcode: recommendcode
			};
			console.log(JSON.stringify(data));
			mui.post(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			}, 'json');
		}
	},
	// 用户登录
	login: function(login_type, telphone, code, successCallback, failCallback) {
		console.log('user.login');
		if (network.is_online()) {
			if (!login_type) {
				return false;
			}
			switch (login_type) {
				case 'account':
					break;
				case 'sms':
					break;
				
			}
			var url = network.gen_url('/oauth/token');
			var data = {
				type: login_type,
				uuid: plus.device.uuid,
				username: telphone,
				password: code,
				device_cid:plus.push.getClientInfo().clientid,
				device_doken:plus.push.getClientInfo().token
			};
			console.log(JSON.stringify(data));
			mui.post(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				var resp_string = JSON.stringify(resp.data);
				if (resp.success == true) {
					plus.storage.setItem('is_login', resp_string);
					var url = network.gen_url('/user/my?access_token=' + resp.data.access_token);
					mui.get(url, function(resp) {
						var user_info = JSON.stringify(resp.data);
						console.log(user_info);
						plus.storage.setItem('user_info', user_info);
						if (successCallback) {
							successCallback(resp);
						}
					}, 'json');
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			}, 'json');
		}
	},
	// 退出登录
	logout: function(successCallback, failCallback) {
		console.log('user.logout');
		plus.storage.removeItem('is_login');
		plus.storage.removeItem('user_info');
		if (successCallback) {
			return successCallback();
		}
	},
	// 
	token: function() {
		console.log('user.token');
		var login_flag = plus.storage.getItem('is_login');
		console.log(login_flag);
		return JSON.parse(login_flag);
	},
	// 取当前用户信息
	current: function() {
		console.log('user.current');
		var login_flag = plus.storage.getItem('is_login');
		if (login_flag == null) {
			console.log(false);
			return false;
		} else {
			var user_info = plus.storage.getItem('user_info');
			console.log(user_info);
			return JSON.parse(user_info);
		}
	},
	// 修改用户密码
	change_password: function(old_password, new_password, successCallback, failCallback) {
		console.log('user.change_password');
		if (network.is_online()) {
			var login_flag = user.token();
			var url = network.gen_url('/user/changePassword');
			var data = {
				access_token: login_flag.access_token,
				old_password: old_password,
				new_password: new_password
			};
			console.log(JSON.stringify(data));
			mui.post(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == false) {
					if (failCallback) {
						failCallback(resp);
					}
					mui.toast(resp.data.message);
				} else {
					if (successCallback) {
						successCallback(resp);
					}
				}
			}, 'json');
		}
	},
	// 忘记密码
	forget_password: function(account, vcode, password, successCallback, failCallback) {
		console.log('user.forget_password');
		if (network.is_online()) {
			var url = network.gen_url('/user/forgetPassword');
			var data = {
				account: account,
				vcode: vcode,
				password: password,
				uuid: plus.device.uuid
			};
			console.log(JSON.stringify(data));
			mui.post(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == false) {
					if (failCallback) {
						failCallback(resp);
					}
					mui.toast(resp.data.message);
				} else {
					if (successCallback) {
						successCallback(resp);
					}
				}
			});
		}
	}
};

// 订单相关
var order = {
	my: function(timestamp, page, successCallback, failCallback) {
		if (network.is_online()) {
			var token = user.token();
			var url = network.gen_url('/order/my');
			var data = {
				access_token: token.access_token,
				timestamp: timestamp,
				page: page
			};
			console.log(JSON.stringify(data));
			mui.get(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			}, 'json');
		}
	},
	deleteOne: function(oid, successCallback, failCallback) {
		if (network.is_online()) {
			var token = user.token();
			var url = network.gen_url('/order/deleteOne');
			var data = {
				access_token: token.access_token,
				oid: oid
			};
			console.log(JSON.stringify(data));
			mui.post(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			});
		}
	},
	get_one: function(oid, successCallback, failCallback) {
		if (network.is_online()) {
			var token = user.token();
			var url = network.gen_url('/order/getOneReply');
			var data = {
				access_token: token.access_token,
				oid: oid
			};
			console.log(JSON.stringify(data));
			mui.get(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			});
		}
	}
};

// 版本管理
var version = {
	// 新版本检测
	check_new: function(current_version, successCallback, failCallback) {
		if (network.is_online()) {
			var url = network.gen_url('/version/checkNew');
			var data = {
				current_version: current_version
			};
			console.log(JSON.stringify(data));
			mui.get(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			}, 'json');
		}
	}
};

// 信息发送接收
var message = {
	// 发送任意内容的短消息
	send_sms: function(content, successCallback, failCallback) {
		console.log('message.send_sms');
		if (network.is_online()) {
			var token = user.token();
			var url = network.gen_url('/sms/send');
			var data = {
				access_token: token.access_token,
				content: content
			};
			console.log(JSON.stringify(data));
			mui.post(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			}, 'json');
		}
	},
	// 发送一条验证码消息
	generate_code: function(mobile, successCallback, failCallback) {
		console.log('message.generate_code');
		if (network.is_online()) {
			var url = network.gen_url('/sms/generateCode');
			var data = {
				mobile: mobile,
				uuid: plus.device.uuid
			};
			console.log(JSON.stringify(data));
			mui.get(url, data, function(resp) {
				console.log(JSON.stringify(resp));
				if (resp.success == true) {
					if (successCallback) {
						successCallback(resp);
					}
				} else {
					if (failCallback) {
						failCallback(resp);
					}
				}
			}, 'json');
		}
	},
	// 绑定消息推送信息
	bind_push_info: function() {
		var client_info = plus.push.getClientInfo();
		plus.storage.setItem('push_info', JSON.stringify(client_info));
		alert(JSON.stringify(client_info));
	},
	// 解除绑定消息推送信息
	unbind_push_info: function() {
		plus.storage.removeItem('push_info');
	}
};

// 设置一个跳转页面的方法go_webview
var go_webview = function(selecter, subselecter, need_logged_in) {
	mui(selecter).on('tap', subselecter, function() {
		if (need_logged_in == true) {
			if (user.is_login() == false) {
				var btnArray = ['取消', '确定'];
				mui.confirm('请您在登录后执行本操作', '温馨提示', btnArray, function(e) {
					if (e.index == 1) {
						plus.webview.open('/my-profile/login-account.html', 'login-account', '', 'slide-in-bottom', 250);
					}
				})
				return false;
			}
		}
		var href = this.getAttribute('href');
		plus.webview.open(href, href, '', 'pop-in');
	});
}


mui.plusReady(function() {
	plus.navigator.setLogs(true);
	
	// 设置status bar 颜色
	plus.navigator.setStatusBarBackground('#2C7ED4');
	plus.navigator.setStatusBarStyle('UIStatusBarStyleBlackTranslucent');
	
	// 顶部nav-bar的后退按钮
	mui('.mui-bar-nav').on('tap', '#goback', function() {
		var rel = this.getAttribute('rel');
		plus.webview.currentWebview().close(rel);
	});
});