/*!
 * ======================================================
 * pic_uploader Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
(function() {
	var index = 1;
	var size = null;
	var imageIndexIdNum = 0;
	var starIndex = 0;
	var pic_uploader = {
		imageList: document.getElementById('image-list'),
		submitBtn: document.getElementById('submit')
	};
	var url = api_url+'/doctor/add_order_pic';
	pic_uploader.files = [];
	pic_uploader.uploader = null;  
	pic_uploader.deviceInfo = null; 
	mui.plusReady(function() {
	});
	
	mui.ready(function(){
	});
	

	pic_uploader.getFileInputArray = function() {
		return [].slice.call(pic_uploader.imageList.querySelectorAll('.file'));
	};
	pic_uploader.addFile = function(path) {
		pic_uploader.files.push({name:"images"+index,path:path});
		index++;
	};
	/**
	 * 初始化图片域占位
	 */
	pic_uploader.newPlaceholder = function() {
		var fileInputArray = pic_uploader.getFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
        //小X的点击事件
        closeButton.addEventListener('tap', function (event) {
            setTimeout(function () {
                pic_uploader.imageList.removeChild(placeholder);              
            }, 0);
            if ($(".image-list > div").length == 20 ) {
                pic_uploader.newPlaceholder();
            }              
            return false;
        }, false);
		
		//
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			var self = this;
			var index = (this.id).substr(-1);
			
			plus.gallery.pick(function(e) {
//				console.log("event:"+e);
				var name = e.substr(e.lastIndexOf('/') + 1);
				console.log("name:"+name);
					
				plus.zip.compressImage({
					src: e,
					dst: '_doc/' + name,
					overwrite: true,
					quality: 50
				}, function(zip) {
					size += zip.size  
					console.log("filesize:"+zip.size+",totalsize:"+size);
                    if (size > (50 * 1024 * 1024)) {
                        return mui.toast('抱歉图片总体积过大无法继续添加，请适当筛选图片，或尽量将多份资料展示在一张图片中');
                    }
					if (!self.parentNode.classList.contains('space')) { //已有图片
						pic_uploader.files.splice(index-1,1,{name:"images"+index,path:e});
					} else { //加号
	                    placeholder.classList.remove('space');
                        pic_uploader.addFile(zip.target);
                        if ($(".image-list > div").length < 20 ) {
                            pic_uploader.newPlaceholder();
                        }
					}
					placeholder.style.backgroundImage = 'url(' + zip.target + ')';
				}, function(zipe) {
					mui.toast('压缩失败！')
				});
				
			}, function(e) {
				
			},{});
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(fileInput);
		pic_uploader.imageList.appendChild(placeholder);
	};
	pic_uploader.newPlaceholder();
	pic_uploader.submitBtn.addEventListener('tap', function(event) {
		if(pic_uploader.files.length == 0) {
			mui.toast("请选择需要上传的图片");
			return false;
		}
		
		//判断网络连接
		if(plus.networkinfo.getCurrentType()==plus.networkinfo.CONNECTION_NONE){
			return mui.toast("连接网络失败，请稍后再试");
		}
		pic_uploader.send(mui.extend({},{
			images: pic_uploader.files,
			order_id:plus.webview.currentWebview().order_id
		})) 
	}, false)
	pic_uploader.send = function(content) {
		$("body").loading({"message": "<img src='../js/jquery-loading/loading.gif'>"});
		pic_uploader.uploader = plus.uploader.createUpload(url, {
			method: 'POST'
		}, function(upload, status) {			
            if (status == 200) {
            	plus.webview.currentWebview().opener().evalJS("location.reload();");
            	mui.toast('保存完成');
				mui.back();
            } else {
            	$('body').loading('stop')
                return mui.toast('网络错误，请查看网络连接');
            }			
		});
		//添加上传数据
		mui.each(content, function(index, element) {
			if (index !== 'images') {
//				console.log("addData:"+index+","+element);
				pic_uploader.uploader.addData(index, element)
			} 
		});
		//添加上传文件
		mui.each(pic_uploader.files, function(index, element) {
			var f = pic_uploader.files[index];
//			console.log("addFile:"+JSON.stringify(f));
			pic_uploader.uploader.addFile(f.path, {
				key: f.name
			});
		});
		
		//开始上传任务
		pic_uploader.uploader.start();

	};
	
})();