/*!
 * ======================================================
 * FeedBack Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
(function ($) {
    var index = 1;
    var size = null;
    var imageIndexIdNum = 0;
    var starIndex = 0;
    var doctor_order = {
        doc_id: document.getElementById('docid'),
        hos_id: document.getElementById('hosid'),
        type: document.getElementById('order-type'),
        patient_name: document.getElementById('patient-name'),
        disease_name: document.getElementById('disease-name'),
        disease_description: document.getElementById('disease-description'),
        allow_clause: document.getElementById('allow-clause'),
        imageList: document.getElementById('image-list'),
        submitBtn: document.getElementById('submit')
    };
    var url = api_url+'/doctor/order'; 
    doctor_order.files = [];
    doctor_order.uploader = null;
    doctor_order.deviceInfo = null;
    mui.plusReady(function () {
        //设备信息，无需修改
        doctor_order.deviceInfo = {
            appid: plus.runtime.appid,
            imei: plus.device.imei, //设备标识
            images: doctor_order.files, //图片文件
            p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
            md: plus.device.model, //设备型号
            app_version: plus.runtime.version,
            plus_version: plus.runtime.innerVersion, //基座版本号
            os: mui.os.version,
            net: '' + plus.networkinfo.getCurrentType()
        }
    });
 
    doctor_order.getFileInputArray = function () {
        return [].slice.call(doctor_order.imageList.querySelectorAll('.file'));
    };
    doctor_order.addFile = function (path) {
        doctor_order.files.push({name: "images" + index, path: path});
        index++;
    };
    /**
     * 初始化图片域占位
     */
    doctor_order.newPlaceholder = function () {
        var fileInputArray = doctor_order.getFileInputArray();
        if (fileInputArray &&
            fileInputArray.length > 0 &&
            fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
            return;
        }
        ;
        imageIndexIdNum++;
        var placeholder = document.createElement('div');
        placeholder.setAttribute('class', 'image-item space');
        //删除图片
        var closeButton = document.createElement('div');
        closeButton.setAttribute('class', 'image-close');
        closeButton.innerHTML = 'X';
        //小X的点击事件
        closeButton.addEventListener('tap', function (event) {
            setTimeout(function () {
                doctor_order.imageList.removeChild(placeholder);              
            }, 0);
            if ($(".image-list > div").length == 20 ) {
                doctor_order.newPlaceholder();
            }              
            return false;
        }, false);

        //
        var fileInput = document.createElement('div');
        fileInput.setAttribute('class', 'file');
        fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
        fileInput.addEventListener('tap', function (event) {
            var self = this;
            var index = (this.id).substr(-1);

            plus.gallery.pick(function (e) {
//				console.log("event:"+e);
                var name = e.substr(e.lastIndexOf('/') + 1);
                console.log("name:" + name);

                plus.zip.compressImage({
                    src: e,
                    dst: '_doc/' + name,
                    overwrite: true,
                    quality: 50
                }, function (zip) {
                    size += zip.size
                    console.log("filesize:" + zip.size + ",totalsize:" + size);
                    if (size > (50 * 1024 * 1024)) {
                        return mui.toast('抱歉图片总体积过大无法继续添加，请适当筛选图片，或尽量将多份资料展示在一张图片中');
                    }
                    if (!self.parentNode.classList.contains('space')) { //已有图片
                        doctor_order.files.splice(index - 1, 1, {name: "images" + index, path: e});
                    } else { //加号
                        placeholder.classList.remove('space');
                        doctor_order.addFile(zip.target);
                        if ($(".image-list > div").length < 20 ) {
                            doctor_order.newPlaceholder();
                        }
                    }
                    placeholder.style.backgroundImage = 'url(' + zip.target + ')';
                }, function (zipe) {
                    mui.toast('压缩失败！')
                });
            }, function (e) {
                //mui.toast(e.message);
            }, {});
        }, false);
        placeholder.appendChild(closeButton);
        placeholder.appendChild(fileInput);
        doctor_order.imageList.appendChild(placeholder);
    };
    doctor_order.newPlaceholder();
    doctor_order.submitBtn.addEventListener('tap', function (event) {
    	var user_info = user.current();
    	var user_token = user.token();

        if (doctor_order.type.value == '') {
            return mui.toast('请选择就诊类型');
        }
        if (doctor_order.patient_name.value == '') {
            return mui.toast('请填写患者名称');
        }
        if (doctor_order.disease_name.value == '') {
            return mui.toast('请填写疾病名称');
        }
        if (doctor_order.disease_description.value == '') {
            return mui.toast('请填写病情描述');
        }
        if (!doctor_order.allow_clause.checked) {
            return mui.toast('请确认同意医瘤网《在线服务条款》');
        }
        
        doctor_order.send(mui.extend({}, doctor_order.deviceInfo, {
        	token:user_token.access_token,
        	user_id:user_info.id,
        	user_phone:user_info.account,
        	doc_id:doctor_order.doc_id.value,
        	hos_id:doctor_order.hos_id.value,
            type: doctor_order.type.value,
            patient_name: doctor_order.patient_name.value,
            disease_name: doctor_order.disease_name.value,
            disease_description: doctor_order.disease_description.value,
            images: doctor_order.files
        }))
    }, false)
    
    doctor_order.send = function (content) {
 		$("body").loading({"message": "<img src='../js/jquery-loading/loading.gif'>"});
        doctor_order.uploader = plus.uploader.createUpload(url, {
            method: 'POST'
        }, function (upload, status) {
            if (status == 200) {
                var data = JSON.parse(upload.responseText);
                $('body').loading('stop')
				if(data.result == 'succeed'){
					 mui.openWindow({
						url:'payment.html',
						id:'payment.html',
						extras:{
							order_id:data.id  //扩展参数
						}
					});
				} else {
					return mui.toast('订单创建失败，请稍后再试');
				}
           } else {
            	$('body').loading('stop')
                return mui.toast('网络错误，请查看网络连接');
            }
        });
        //添加上传数据
        mui.each(content, function (index, element) {
            if (index !== 'images') {
//				console.log("addData:"+index+","+element);
                doctor_order.uploader.addData(index, element)
            } else {
		        mui.each(element, function (index, value) {
		            var f = element[index];
		            doctor_order.uploader.addFile(f.path, {
		                key: f.name
		            });
		        });            	
            }
        });
		//开始上传任务
        doctor_order.uploader.start();

    };

})(jQuery);